Description

Suppose we have a GeoDB or a WFS layer with long field names, i.e. greater than 10. Then, if we use Layer > "Export to" tool
choosing the "Shape format", a warning says that some fields have been truncated showing us how. For instance:

cod_provincia > cod_pr_ia_0
codice_istat > codice_at_0

Firstly, the resulting field name is too long (#2672). Secondly, there aren't duplicate field names in order to justify the final _0 in both
cases. Finally, it's not very understandable the resulting field names in reference to the original ones.
Instead, this is how GDAL/OGR truncates long field names:

Attribute names can only be up to 10 characters long. Starting with version 1.7, the OGR Shapefile driver tries to generate
unique field names. Successive duplicate field names, including those created by truncation to 10 characters, will be truncated
to 8 characters and appended with a serial number from 1 to 99.

(Source: http://www.gdal.org/drv_shapefile.html)
So the examples mentioned before should be:

cod_provincia > cod_provin
codice_istat > codice_ist

Suppose we have another field name cod_provincia_bis. They should become:

cod_provincia > cod_prov_1
codice_istat > codice_ist
cod_provincia_bis > cod_prov_2

Associated revisions
Revision 41745 - 10/06/2014 11:07 AM - Joaquín  del Cerro Murciano

change method to field name truncation in Export-to, refs #2681
History
#1 - 09/03/2014 05:39 AM - Antonio Falciano

The latest example I did is wrong, because the first field should be only truncated according to what GDAL actually does. So the right truncation of the
above mentioned fields should produce:

cod_provincia > cod_provin
codice_istat > codice_ist
cod_provincia_bis > cod_prov_1

#2 - 09/03/2014 11:31 AM - Antonio Falciano
- % Done changed from 0 to 100
- Assignee set to Joaquín  del Cerro Murciano
- File ExporttoShapeService.patch added

I attach a patch that implements the GDAL truncation method when exporting to shp, like explained in its comments:

/*
* GDAL field name truncation method (extended from 100 to 255)
* THISISAVERYLONGNAME => THISISAVER, THISISAV_1 ... THISISAV_9,
* THISISAV10 ... THISISAV99, THISISA100 ... THISISA255
* (255 = max number of fields in a SHP)
*/

See also #2672.

#3 - 09/03/2014 12:20 PM - Antonio Falciano
- File ExporttoShapeService_final.patch added

Ops... After further tests, I've discovered an error with the final index (that was starting from 2 instead of 1) in the previous patch, so I attach a revised
version of it. I'm sorry for the inconvenience.

#4 - 09/03/2014 01:09 PM - Antonio Falciano
- File field_name_truncation_test.csv added
- File ExporttoShapeService_final2.patch added

I've discovered another error (two "=" were missing), sorry... Test cases are quite difficult to find (or to create), so I've made a CSV file (in attachment)
to add as table, add as an event theme to a view and finally to export in order to verify how the field name truncation works.

#5 - 09/09/2014 03:45 AM - Álvaro Anguix
- Has patch set to Yes
#6 - 09/26/2014 03:46 AM - Antonio Falciano
- Target version set to 2.1.0-2259-rc3

#7 - 10/06/2014 11:07 AM - Joaquín  del Cerro Murciano
- Target version changed from 2.1.0-2259-rc3 to 2.1.0-2248-testing
- Status changed from New to Fixed

#8 - 10/14/2014 07:51 AM - Álvaro Anguix
- Status changed from Fixed to Closed

Files
ExporttoShapeService.patch 2.12 KB 09/03/2014 Antonio Falciano
ExporttoShapeService_final.patch 2.11 KB 09/03/2014 Antonio Falciano
ExporttoShapeService_final2.patch 2.11 KB 09/03/2014 Antonio Falciano
field_name_truncation_test.csv 359 Bytes 09/03/2014 Antonio Falciano
